package com.snowchen.snglfx17.AppCore;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class ConfigCore {
    public static class CreateDirectory {
        public static void createDirectoryIfNotExists(String directoryName) {
            Path rootPath = Paths.get("");
            Path directoryPath = rootPath.resolve(directoryName);

            if (!Files.exists(directoryPath)) {
                try {
                    Files.createDirectories(directoryPath);
                    System.out.println("目录 " + directoryName + " 已成功创建在根目录下。");
                } catch (IOException e) {
                    System.err.println("创建目录时发生错误: " + e.getMessage());
                }
            } else {
                System.out.println("目录 " + directoryName + " 已经存在于根目录下。");
            }
        }
    }

    public static class CreateConfig {
        public static boolean checkAndCreateFile(String directoryPath, String fileName) {
            Path filePath = Paths.get(directoryPath, fileName);

            if (!Files.exists(filePath)) {
                try {
                    Path directory = Paths.get(directoryPath);
                    if (!Files.exists(directory)) {
                        Files.createDirectories(directory);
                    }
                    Files.createFile(filePath);
                    return true;
                } catch (IOException e) {
                    System.err.println("创建文件时发生错误: " + e.getMessage());
                    return false;
                }
            }
            return false;
        }
    }

    public static class SaveData {
        public static void saveConfig(String filePath, Object config) {
            Gson gson = new GsonBuilder().setPrettyPrinting().create();
            try (FileWriter writer = new FileWriter(filePath)) {
                gson.toJson(config, writer);
            } catch (IOException e) {
                System.err.println("保存配置时发生错误: " + e.getMessage());
            }
        }

        public static <T> T loadConfig(String filePath, Class<T> type) {
            if (Files.exists(Paths.get(filePath))) {
                Gson gson = new Gson();
                try (Reader reader = Files.newBufferedReader(Paths.get(filePath))) {
                    return gson.fromJson(reader, type);
                } catch (IOException e) {
                    System.err.println("加载配置时发生错误: " + e.getMessage());
                }
            }
            return null;
        }
    }
}