package com.snowchen.snglfx17.AppCore;

import org.to2mbn.jmccc.mcdownloader.MinecraftDownloader;
import org.to2mbn.jmccc.mcdownloader.MinecraftDownloaderBuilder;
import org.to2mbn.jmccc.mcdownloader.RemoteVersionList;
import org.to2mbn.jmccc.mcdownloader.download.concurrent.DownloadCallback;
import org.to2mbn.jmccc.mcdownloader.download.tasks.DownloadTask;
import org.to2mbn.jmccc.mcdownloader.download.concurrent.CallbackAdapter;
import org.to2mbn.jmccc.option.MinecraftDirectory;
import org.to2mbn.jmccc.version.Version;


public class DownloadCore {

    public static void DownloadMinecraftVersion() {
        MinecraftDirectory dir = new MinecraftDirectory("/.minecraft");
        MinecraftDownloader downloader = MinecraftDownloaderBuilder.buildDefault();
        downloader.downloadIncrementally(dir, "1.20.4", new CallbackAdapter<Version>() {

            @Override
            public void failed(Throwable e) {
                // when the task fails
            }

            @Override
            public void done(Version result) {
                // when the task finishes
            }

            @Override
            public void cancelled() {
                // when the task cancels
            }

            @Override
            public <R> DownloadCallback<R> taskStart(DownloadTask<R> task) {
                // when a new sub download task starts
                // return a DownloadCallback to listen the status of the task
                return new CallbackAdapter<R>() {

                    @Override
                    public void done(R result) {
                        // when the sub download task finishes
                    }

                    @Override
                    public void failed(Throwable e) {
                        // when the sub download task fails
                    }

                    @Override
                    public void cancelled() {
                        // when the sub download task cancels
                    }

                    @Override
                    public void updateProgress(long done, long total) {
                        // when the progress of the sub download task has updated
                    }

                    @Override
                    public void retry(Throwable e, int current, int max) {
                        // when the sub download task fails, and the downloader decides to retry the task
                        // in this case, failed() won't be called
                    }
                };
            }
        });
        downloader.shutdown();
    }
    public static void DownloadRemoteVersionList(){
        MinecraftDownloader downloader = MinecraftDownloaderBuilder
                .create()
                .build();
        downloader.fetchRemoteVersionList(new CallbackAdapter<RemoteVersionList>() {

            @Override
            public void done(RemoteVersionList result) {
                System.out.printf("版本列表下载完成：%s%n", result);
            }

            // ............省略其它方法
        });
    }

    }


