package com.snowchen.snglfx17;

import atlantafx.base.theme.NordDark;
import atlantafx.base.theme.NordLight;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Stage;
import java.io.IOException;
import java.time.LocalTime;
import javafx.scene.image.Image;

public class HelloApplication extends Application {
    @Override
    public void start(Stage stage) throws IOException {
        // 加载图标
        Image icon = new Image(getClass().getResourceAsStream("/icons/icon.png"));

        // 设置窗口图标
        stage.getIcons().add(icon);

        // 获取当前时间
        LocalTime now = LocalTime.now();
        // 定义晚上7点和早上6点的时间
        LocalTime sevenPm = LocalTime.of(19, 0); // 晚上7点
        LocalTime sixAm = LocalTime.of(6, 0); // 早上6点

        // 根据当前时间选择主题
        if (now.isAfter(sevenPm) || now.isBefore(sixAm)) {
            // 如果当前时间是晚上7点以后或早上6点以前，设置暗黑主题
            Application.setUserAgentStylesheet(new NordDark().getUserAgentStylesheet());
            System.out.println("晚上好");
        } else {
            // 否则，设置明亮主题
            Application.setUserAgentStylesheet(new NordLight().getUserAgentStylesheet());
        }

        // 加载界面文件
        FXMLLoader fxmlLoader = new FXMLLoader(HelloApplication.class.getResource("hello-view.fxml"));
        // 创建场景
        Scene scene = new Scene(fxmlLoader.load(), 675, 450);
        // 设置窗口标题
        stage.setTitle("SNGL Alpha Test");
        // 设置窗口场景
        stage.setScene(scene);
        // 显示窗口
        stage.show();
    }


    public static void main(String[] args) {
        launch(args);
    }
}